# -*- rpm-spec -*-

# Version options
%define kernel_base_version	2.6.12
%define kernel_extra_version	%nil
# Numeric extra version scheme developed by Alexander Bokovoy:
# 0.0.X -- preX
# 0.X.0 -- rcX
# 1.0.0 -- release
%define kernel_extra_version_numeric 1.0.0
%define krelease alt6

%define base_flavour	std26
%define flavour		%base_flavour-smp

# Build options
# You can change compiler version by editing this line:
%define kgcc_version	3.4

# Enable/disable SGML docs formatting
%def_disable docs

# Fixes:
%add_patch_list kernel-fix-build
%add_patch_list kernel-fix-core
%add_patch_list kernel-fix-acpi
%add_patch_list kernel-fix-fs
%add_patch_list kernel-fix-net
#add_patch_list kernel-fix-drivers-atm
%add_patch_list kernel-fix-drivers-block
%add_patch_list kernel-fix-drivers-char
%add_patch_list kernel-fix-drivers-net
%add_patch_list kernel-fix-drivers-usb
#add_patch_list kernel-fix-drivers-i2c
%add_patch_list kernel-fix-drivers-ide
%add_patch_list kernel-fix-drivers-ieee1394
%add_patch_list kernel-fix-drivers-input
%add_patch_list kernel-fix-drivers-md
%add_patch_list kernel-fix-drivers-media
%add_patch_list kernel-fix-drivers-pci
%add_patch_list kernel-fix-drivers-sound
#add_patch_list kernel-fix-drivers-serial
%add_patch_list kernel-fix-drivers-scsi
#add_patch_list kernel-fix-drivers-parport
%add_patch_list kernel-fix-drivers-video
%add_patch_list kernel-fix-security
%add_patch_list kernel-fix-core-skbuff

# Features:

#add_patch_list kernel-feat-drivers-drm
%add_patch_list kernel-feat-drivers-video-splash
%add_patch_list kernel-feat-drivers-input
%add_patch_list kernel-feat-drivers-lirc
%add_patch_list kernel-feat-drivers-net-sk98lin
%add_patch_list kernel-feat-drivers-pktcdvd
%add_patch_list kernel-feat-fs-squashfs
%add_patch_list	kernel-feat-net-ppp-mppe
%add_patch_list	kernel-feat-evms-nodm

# imz: Unicode support in VT/console
#add_patch_list kernel-feat-drivers-console-unicode
# Although this patch changes the interface between the kernel and loadkeys,
# I do not put a Conflicts for the old console-tools here,
# because the old loadkeys works fine the new kernel interface.

## Don't edit below this line ##################################

%define kversion	%kernel_base_version%kernel_extra_version
%define modules_dir	/lib/modules/%kversion-%flavour-%krelease

Name: kernel-image-%flavour
Version: %kversion
Release: %krelease

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
Url: http://www.kernel.org/
Packager: Kernel Maintainers Team <kernel@packages.altlinux.org>

%set_kernel_arches i586 x86_64

ExclusiveOS: Linux

BuildRequires: dev86 flex
BuildRequires: libdb4-devel
BuildRequires: gcc%kgcc_version
BuildRequires: kernel-source-%{kernel_base_version} = %{kernel_extra_version_numeric}
BuildRequires: kernel-build-tools >= 0.8, modutils >= 2.4.27-alt1
BuildRequires: %get_patch_list

%if_enabled docs
BuildRequires: xmlto transfig ghostscript
%endif

%if_enabled ccache
BuildRequires: ccache
%endif

%ifdef use_ccache
BuildRequires: ccache
%endif

Requires: bootloader-utils >= 0.3-alt1
Requires: modutils >= 2.4.27-alt1
Requires: mkinitrd >= 1:2.9.2-alt1
Requires: startup >= 0.8.3-alt1

Provides: kernel = %kversion

Prereq: coreutils
Prereq: modutils >= 2.4.27
Prereq: mkinitrd >= 1:2.9.2-alt1

%description
This package contains the Linux kernel that is used to boot and run
your system.

The "std26" variant of kernel packages is a generic 2.6.x kernel which
should support wide range of hardware, but does not contain patches
which are useful only for some special applications (and may have
undesirable side effects in other cases).  This is the default 2.6.x
kernel variant for ALT Linux distributions.

Most hardware drivers for this kernel are built as modules.  Some of
these drivers are built separately from the kernel; they are available
in separate packages (kernel-modules-*-%flavour).

Patches included:%format_patch_list

%package -n kernel-modules-oss-%flavour
Summary: OSS sound driver modules (obsolete)
Group: System/Kernel and hardware
Provides:  kernel-modules-oss-%kversion-%flavour-%krelease = %version-%release
Conflicts: kernel-modules-oss-%kversion-%flavour-%krelease < %version-%release
Conflicts: kernel-modules-oss-%kversion-%flavour-%krelease > %version-%release
Prereq: coreutils
Prereq: modutils
Prereq: %name = %version-%release
Requires(postun): %name = %version-%release

%description -n kernel-modules-oss-%flavour
This package contains OSS sound driver modules for the Linux kernel
package %name-%version-%release.

These drivers are declared obsolete by the kernel maintainers; ALSA
drivers should be used instead.  However, the older OSS drivers may be
still useful for some hardware, if the corresponding ALSA drivers do
not work well.

Install this package only if you really need it.

%package -n kernel-headers-%flavour
Summary: Header files for the Linux kernel
Group: System/Kernel and hardware
Requires: kernel-headers-common >= 1.1.5
Provides: kernel-headers = %version

%description -n kernel-headers-%flavour
This package makes Linux kernel headers corresponding to the Linux
kernel package %name-%version-%release available for building
userspace programs (if this version of headers is selected by
adjust_kernel_headers).

Note that such usage of kernel headers in userspace is not supported
by the upstream kernel maintainers and often breaks compilation.
Therefore installing and using this package is not recommended.

%package -n kernel-headers-modules-%flavour
Summary: Headers and other files needed for building kernel modules
Group: System/Kernel and hardware
Requires: kernel-headers-%flavour = %version-%release
Requires: gcc%kgcc_version

%description -n kernel-headers-modules-%flavour
This package contains header files, Makefiles and other parts of the
Linux kernel build system which are needed to build kernel modules for
the Linux kernel package %name-%version-%release.

If you need to compile a third-party kernel module for the Linux
kernel package %name-%version-%release, install this package
and specify %_prefix/src/linux-%version-%flavour as the kernel source
directory.

%package -n kernel-doc-%base_flavour
Summary: Linux kernel %kversion-%base_flavour documentation
Group: System/Kernel and hardware

%description -n kernel-doc-%base_flavour
This package contains documentation files for ALT Linux kernel packages:
 * kernel-image-%base_flavour-up-%kversion-%krelease
 * kernel-image-%base_flavour-smp-%kversion-%krelease

The documentation files contained in this package may be different
from the similar files in upstream kernel distributions, because some
patches applied to the corresponding kernel packages may change things
in the kernel and update the documentation to reflect these changes.

%prep
%setup -cT -n kernel-image-%flavour-%kversion-%krelease
%__rm -rf kernel-source-%kernel_base_version
%__tar -jxf %kernel_src/kernel-source-%kernel_base_version.tar.bz2
%setup -D -T -n kernel-image-%flavour-%kversion-%krelease/kernel-source-%kernel_base_version

echo "patches = %_patch_list"

%apply_patches 2.6

# this file should be usable both with make and sh (for broken modules
# which do not use the kernel makefile system)
echo 'export GCC_VERSION=%kgcc_version' > gcc_version.inc

%__subst 's/EXTRAVERSION[[:space:]]*=.*/EXTRAVERSION = %kernel_extra_version-%flavour-%krelease/g' Makefile
%__subst 's/CC.*$(CROSS_COMPILE)gcc/CC         := $(shell echo $${GCC_USE_CCACHE:+ccache}) gcc-%kgcc_version/g' Makefile

# get rid of unwanted files resulting from patch fuzz
find . -name "*.orig" -delete -or -name "*~" -delete

%build
KernelVer=%kversion-%flavour-%krelease

echo "Building Kernel $KernelVer"

%make_build mrproper

%__cp -vf %{get_kernel_config %_target_cpu} .config

%make_build oldconfig
%make_build include/linux/version.h
%make_build bzImage
%make_build modules

echo "Kernel built $KernelVer"

%if_enabled docs
# psdocs, pdfdocs don't work yet
%make_build htmldocs
%endif

%install
KernelVer=%kversion-%flavour-%krelease

%__install -Dp -m644 System.map %buildroot/boot/System.map-$KernelVer
%__install -Dp -m644 arch/%base_arch/boot/bzImage %buildroot/boot/vmlinuz-$KernelVer
%__install -Dp -m644 .config %buildroot/boot/config-$KernelVer

%__make modules_install INSTALL_MOD_PATH=%buildroot

%__install -d %buildroot%_prefix/include/linux-%version-%flavour/include

pushd include
%__cp -a . %buildroot%_prefix/include/linux-%version-%flavour/include
popd

# remove asm-* include files for other architectures
pushd %buildroot%prefix/include/linux-%version-%flavour/include
for dir in asm-*; do
	[ "$dir" = "asm-generic" ] && continue
	[ "$dir" = "asm-%base_arch" ] && continue
	%__rm -rf -- "$dir"
done
popd

# drivers-headers install
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/scsi
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/net/wireless
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/char/drm
%__cp -a drivers/scsi/{{scsi,hosts,scsi_typedefs}.h,scsi_module.c} \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/scsi/
%__cp -a drivers/net/wireless/ieee802_11.h \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/net/wireless/
%__cp -a drivers/char/drm/{drm,drm_os_linux,drmP}.h \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/char/drm/

%__install -d %buildroot%_prefix/src/linux-%version-%flavour
pushd %buildroot%_prefix/src/linux-%version-%flavour
%__ln_s -f ../../include/linux-%version-%flavour/include ./include
popd

# Install files required for building external modules (in addition to headers)
KbuildFiles="
	Makefile
	Module.symvers
	arch/%base_arch/Makefile

	scripts/pnmtologo
	scripts/mod/modpost
	scripts/mkversion
	scripts/mod/mk_elfconfig
	scripts/kconfig/conf
	scripts/mkcompile_h
	scripts/makelst
	scripts/Makefile.modpost
	scripts/Makefile.modinst
	scripts/Makefile.lib
	scripts/Makefile.clean
	scripts/Makefile.build
	scripts/Makefile
	scripts/kallsyms
	scripts/genksyms/genksyms
	scripts/basic/fixdep
	scripts/extract-ikconfig
	scripts/conmakehash
	scripts/checkversion.pl
	scripts/checkincludes.pl
	scripts/checkconfig.pl
	scripts/bin2c
	scripts/gcc-version.sh

	.config
	gcc_version.inc
"
for f in $KbuildFiles; do
	[ -x "$f" ] && mode=755 || mode=644
	%__install -Dp -m$mode "$f" \
		%buildroot%_prefix/src/linux-%version-%flavour/"$f"
done

%__rm -f %buildroot%modules_dir/{build,source}
%__ln_s %_prefix/src/linux-%version-%flavour %buildroot%modules_dir/build

# install documentation
%if_enabled docs
%__install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/
%__cp -a Documentation/* %buildroot%_docdir/kernel-doc-%base_flavour-%version/
%__install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/
for dir in aacraid; do
	%__install -d \
		%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/$dir/
	%__cp -a drivers/scsi/$dir/README* \
		%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/$dir/
done
find %buildroot%_docdir/kernel-doc-%base_flavour-%version/DocBook \
	-maxdepth 1 -type f -not -name '*.html' -delete
%endif # if_enabled docs

%post
%post_kernel_image %kversion-%flavour-%krelease

%preun
%preun_kernel_image %kversion-%flavour-%krelease

%post -n kernel-modules-oss-%flavour
%post_kernel_modules %kversion-%flavour-%krelease

%postun -n kernel-modules-oss-%flavour
%postun_kernel_modules %kversion-%flavour-%krelease

%post -n kernel-headers-%flavour
%post_kernel_headers %kversion-%flavour-%krelease

%postun -n kernel-headers-%flavour
%postun_kernel_headers %kversion-%flavour-%krelease

%files
/boot/vmlinuz-%kversion-%flavour-%krelease
/boot/System.map-%kversion-%flavour-%krelease
/boot/config-%kversion-%flavour-%krelease
%modules_dir
%exclude %modules_dir/build

# OSS drivers
%exclude %modules_dir/kernel/sound/oss
%ifarch %ix86
%exclude %modules_dir/kernel/drivers/media/radio/miropcm20.ko
%exclude %modules_dir/kernel/drivers/media/radio/miropcm20-rds.ko
%endif
%exclude %modules_dir/kernel/drivers/usb/class/audio.ko
%exclude %modules_dir/kernel/drivers/usb/class/usb-midi.ko

%files -n kernel-modules-oss-%flavour
%modules_dir/kernel/sound/oss
%ifarch %ix86
%modules_dir/kernel/drivers/media/radio/miropcm20.ko
%modules_dir/kernel/drivers/media/radio/miropcm20-rds.ko
%endif
%modules_dir/kernel/drivers/usb/class/audio.ko
%modules_dir/kernel/drivers/usb/class/usb-midi.ko

%files -n kernel-headers-%flavour
%_prefix/include/linux-%version-%flavour

%files -n kernel-headers-modules-%flavour
%_prefix/src/linux-%version-%flavour
%modules_dir/build

%if_enabled docs
%files -n kernel-doc-%base_flavour
%doc %_docdir/kernel-doc-%base_flavour-%version
%endif

%changelog
* Wed Oct 26 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.12-alt6
- Updated kernel-fix-drivers-net:
  + sis190 driver backport from 2.6.13
- Modified configuration:
  + CONFIG_SIS190=m: enabled sis190 driver

* Mon Oct 24 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.12-alt5
- Updated kernel-fix-core:
  + prevent recursive faults in do_exit() by leaving the task alone and wait
    for reboot
  + NPTL signal delivery deadlock fix
  + fix semundo lock leakage due to broken optimization for single-thread case
  + irqpoll (workaround for wrong interrupt routing) backport to 2.6.12
- Updated kernel-fix-drivers-block:
  + cciss: fix wrong PCI ID, add PCI ID for SA E300
- Updated kernel-fix-drivers-char:
  + amd64-agp: add SiS 760 chip support
- Updated kernel-fix-drivers-ide:
  + fix ide-disk inability to handle LBA only devices
  + fix IDE timing violation on reset
  + do not probe legacy ISA/VESA IDE ports 0x1e8, 0x168, 0x1e0, 0x160 on PCI
    systems
  + amd74xx: add PCI ID for NFORCE-MCP55 IDE controller
  + it812x: new driver for ITE IT8211 IDE controller and IT8212 IDE RAID
    controller
  + serverworks: add PCI ID for IDE controller in the HT1000 (BCM5785)
    southbridge
  + via82cxxx: add VT6410 support
- Updated kernel-fix-drivers-ieee1394:
  + ohci1394: init spinlock before registering IRQ handler
- Updated kernel-fix-drivers-input:
  + i8042: add Alienware Sentia to NOMUX blacklist
  + ns558: probe PnP gameports before ISA, so that PnP ports that are already
    enabled get detected as PnP
- Updated kernel-fix-drivers-media:
  + skystar2: fix oops on module unload due to irq number being copied too
    early (before pci_enable_device() has set the proper irq)
- Updated kernel-fix-drivers-net:
  + forcedeth: add PCI IDs for MCP51 and MCP55
  + forcedeth: poll for link changes
  + forcedeth: always initialize link settings in nv_open()
  + r8169: add PCI ID for USR 997902
  + tulip: add PCI ID for Planex FNW-3602-TX
  + tulip: add workarounds for ULi5261 chip quirks (#8331)
- Updated kernel-fix-drivers-scsi:
  + libata: detect PATA->SATA bridges and apply workarounds
  + libata: fix read capacity handling for more than 2TB
  + libata: fix read/write translation edge cases (sector count == 0)
  + megaraid_mbox: update driver to version 2.20.4.6 (adds support for all
    Dobson, Lindsay, and Verde based products regardless of the subsystem ID)
  + sata_nv: add support for MCP51 and MCP55 controllers
  + sata_promise: add PDC20619 chip support (Promise TX4000 controller)
  + sata_promise: add PDC40718 chip support (Promise SATA300 TX4 controller)
  + sata_promise: add PDC40519 chip support (Promise TX4200 controller)
  + sata_promise: do not attempt to use SATA phy on PATA controllers
  + sata_svw: add PCI ID for SATA controller in the HT1000 (BCM5785)
    southbridge
  + sg: fix a memory leak in devices seq_file implementation
- Updated kernel-fix-drivers-usb:
  + pegasus: add Elecom (Laneed) LD-USBL/TX support
  + usbnet: fix gl_skb/skb type error in genelink driver
- Updated kernel-fix-net:
  + ipsec: restrict socket policy loading to CAP_NET_ADMIN (CAN-2005-2555)
  + ipv4: fix DST leak in icmp_push_reply()
  + ipv6: fix SKB leak in ip6_input_finish()
- Updated kernel-fix-security:
  + fix cmsg copying from userspace (CAN-2005-2490)
  + fix unchecked __get_user in IP raw sockets (CAN-2005-2492)
  + fix possible infinite loop in ipv6 (CAN-2005-2973)
  + fix module parameter permissions in drm (CAN-2005-3179)
  + fix information leak in orinoco driver (CAN-2005-3180)
  + fix names_cache memory leak (CAN-2005-3181)
- Modified configuration:
  + CONFIG_BLK_DEV_IT821X=m: enabled ITE 812x driver
  + CONFIG_DEBUG_STACKOVERFLOW=y (x86 only): enable checks for stack overflow
    in IRQ handler entry code

* Sun Aug 14 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.12-alt4
- Updated kernel-fix-acpi:
  - removed suspend-setup-leave patch (#6785, #7539)
- Updated kernel-fix-core:
  + do not BUG() when module per-cpu alignment cannot be met
  + fix powernow oops on dual-core Athlon
  + clear the returned argument in sys_get_thread_area()
  + check if mode < 0 in sys_set_mempolicy()
  + x86_64: fix memleak from malicious 32bit elf program
  + x86_64: fixing smpboot timing problem
  + x86_64: fix SRAT for non dual-core AMD systems
- Updated kernel-fix-drivers-char:
  + rocket: fix ldisc ref count handling
  + moxa: fix tty driver name which was conflicting with the BSD-style pty
    driver, therefore some ports were inaccessible when using udev
- Updated kernel-fix-drivers-scsi:
  + qla2xxx: correct handling of fc_remote_port_add() failure case
- Updated kernel-fix-fs:
  + fix BIO cloning bug which could result in data corruption with some MD
    setups
  + check input buffer size in zisofs
- Updated kernel-fix-net:
  + fix early vlan adding leads to not functional device
  + xfrm: fix possible overflow of sock->sk_policy
  + fix potential memory corruption in NAT code
  + fix deadlock in ip6_queue
  + wait until all references to ip_conntrack_untracked are dropped on unload
  + fix signedness issues in net/core/filter.c
- Updated kernel-fix-security:
  + fix keyring handling bugs (CAN-2005-2098, CAN-2005-2099)
- Updated kernel-feat-drivers-net-sk98lin:
  + version 8.23
- Rebuild with new kernel-feat-fs-squashfs.

* Mon Jul 25 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.12-alt3
- Fixed kernel-fix-core-skbuff so that it does nothing for 32-bit architectures
  and enabled it for all architectures to avoid arch-specific BuildRequires.
- Updated kernel-fix-acpi:
  + if ACPI doesn't find an irq listed, don't accept 0 as a valid PCI irq
  + fix PNPACPI resource parser (#7392)
- Updated kernel-fix-drivers-char:
  + fix tpm driver initialization which was messing up other devices
  + add missing NULL checks in tty ioctl code
- Updated kernel-fix-drivers-media:
  + cx88: set hue offset to 128 to correct behavior in cx88 cards
- Updated kernel-fix-drivers-net:
  + fix locking in the shaper driver
- Updated kernel-fix-fs:
  + fix locking in __unregister_chrdev_region()
- Updated kernel-fix-net:
  + revert the nf_reset change completely (previous fix was not enough); drop
    conntrack references manually before packets are queued to packet sockets
- Added kernel-fix-drivers-input:
  + fix problem with trackpoint attached to synaptics passthrough port

* Thu Jul 14 2005 Anton D. Kachalov <mouse@altlinux.org> 2.6.12-alt2
- Per-arch configuration
- Added kernel-fix-core-skbuff for x86_64 only

* Sat Jul 02 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.12-alt1
- 2.6.12.
- Updated kernel-fix-build, kernel-fix-core, kernel-fix-drivers-char,
  kernel-fix-drivers-ide, kernel-fix-drivers-media, kernel-fix-drivers-net,
  kernel-fix-drivers-pci, kernel-fix-drivers-scsi, kernel-fix-drivers-usb,
  kernel-fix-drivers-video, kernel-fix-fs, kernel-fix-net, kernel-fix-security:
  - removed obsolete patches
- Updated kernel-fix-acpi:
  + updated acpi-attrs and suspend-setup-leave patches for 2.6.12
  + call acpi_register_gsi() even for default PCI interrupt assignment (needed
    to set PCI interrupts to level/low properly)
- Updated kernel-fix-core:
  + round size in remap_pfn_range() up to a page boundary
  + add "memory" clobbers to string.h functions to avoid memory access
    reordering by gcc
- Updated kernel-fix-drivers-media:
  + updated Manli and BeholdTV remote control support patch for 2.6.12
- Updated kernel-fix-drivers-net:
  + e1000: fix spinlock bug
- Updated kernel-fix-drivers-pci:
  + fix typo in drv->driver.shutdown setting for PCI drivers that might result
    in not setting drv->driver.owner
- Updated kernel-fix-drivers-scsi:
  + fix qla2xxx initialization problems
- Updated kernel-fix-drivers-usb:
  + updated old_scheme_first patch for 2.6.12
- Updated kernel-fix-net:
  + fix connection tracking on bridges
  + fix socket hashing bugs in netlink
- Updated kernel-fix-security:
  + CAN-2005-1913
- Updated kernel-feat-drivers-input:
  + updated trackpoint support patch:
    - warning: module parameters for trackpoint device configuration are no
      longer available - use sysfs for configuration;
    - support for scroll emulation in the driver was removed - use the
      appropriate Xorg options
- Updated kernel-feat-drivers-lirc, kernel-feat-drivers-sk98lin:
  + fix compilation with 2.6.12
- Updated kernel-feat-drivers-video-splash:
  + updated splash patch for kernel 2.6.12

* Mon Jun 13 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt11
- Updated kernel-fix-core:
  + fix get_unmapped_area() sanity tests
  + fix try_to_unmap_cluster() passing out-of-bounds pte to pte_unmap()
- Updated kernel-fix-drivers-char:
  + fix mxser receive problem (#6615)
- Updated kernel-fix-drivers-media:
  + bttv: make video capture work on Leadtek WinFast VC100 XP cards
  + saa7134: add support for remote control as used with Manli MuchTV
    M-TV00[12] boards; add BeholdTV 401 and BeholdTV 403 FM card names to the
    Manli entries (#6917)
  + bttv: fix oops on i2c registration failure
- Updated kernel-fix-fs:
  + ext3: fix possible false assertion failure in log_do_checkpoint()
  + hfs, hfsplus: fix leaks and oops in hfsplus
- Updated kernel-fix-net:
  + bridge: avoid poisoning of the bridge forwarding table by frames that have
    been dropped by filtering
  + netem: avoid infinite loop in qdisc_run() when using duplication
  + fix deadlock with ip_queue and tcp local input path
- Modified configuration:
  + (CONFIG_PREEMPT was already disabled in std26-smp)
  + disabled CONFIG_ACPI_DEBUG (workaround for #6304)
  + enabled CONFIG_LOGO_LINUX_CLUT224 (#6975)
  + enabled CONFIG_LOGO_LINUX_MONO (just in case)
- Moved OSS modules for USB audio devices (audio and usb-midi) to the
  kernel-modules-oss-%%flavour subpackage (the snd-usb-audio module from ALSA
  is preferred).

* Sun May 15 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt10
- Updated kernel-fix-security:
  + fix user pointer validation in raw and pktcdvd drivers

* Fri May 13 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt9
- Updated kernel-fix-acpi:
  + show some ACPI device attributes in sysfs (currently hardware_id,
    compatible_ids, bus_address, unique_id)
- Updated kernel-fix-core:
  + remove bogus BUG() in kernel/exit.c
  + fix driver_detach in case the release handler itself calls
    device_release_driver() for the next device (could cause hangs with some
    USB drivers like cdc-acm which bind to more than one interface)
- Updated kernel-fix-drivers-net:
  + 3c59x: only put the device into D3 when we're actually using WOL (some
    devices have trouble with D3 on warm boot)
- Added kernel-fix-drivers-scsi:
  + aacraid: fix oops on management device open for nonexistent controller
  + fix queue lock allocation for SCSI devices (fixes problems with hot
    unplugging, especially with the CFQ scheduler)
    https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=155472
  +  require CAP_ADMIN for SG_IO to tape drives (sending SCSI commands to the
    drive behind the back of the st driver may cause the device state to be
    inconsistent with the internal driver state and cause problems)
  + enable both old and new megaraid drivers (the new megaraid_mbox driver does
    not support some devices which are supported by the old driver)
  + blacklist some broken SCSI scanners which respond to all LUNs
- Updated kernel-fix-drivers-usb:
  + fix bug in visor driver with throttle/unthrottle causing oopses
- Added kernel-fix-drivers-video:
  + fix bad PCI driver name in intelfb
  + fix oops in intelfb due to __initdata marking of module parameters
- Updated kernel-fix-fs:
  + fix race between ext3 make block reservation and reservation window discard
- Updated kernel-fix-net:
  + ebtables: fix smp race under heavy load
  + rose: verify ndigis in rose_rt_ioctl()
- Removed kernel-feat-drivers-drm (switched from in-kernel DRM drivers to the
  DRM CVS).
- Modified configuration:
  + enabled old megaraid driver in addition to the new one
  + disabled intel-mch-agp (it contains a copy of the intel-agp code for Intel
    82865 and 82875 chips intended for the x86_64 architecture; these chips are
    supported by the intel-agp module on i386)
  + disabled DRM support for buildind external DRM modules from DRI CVS;
    removed corresponding Provides from the package
- Reverted kernel-headers-%%flavour and kernel-headers-modules-%%flavour layout
  modification from 2.6.11-alt7 (causes problems when upgrading old packages).

* Wed May 11 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt8
- Updated kernel-fix-security:
  + fix ELF core dump issue (CAN-2005-1263)

* Tue May 10 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt7
- Added kernel-feat-drivers-net-sk98lin:
  + updated sk98lin driver to 8.16 from vendor
- Updated kernel-fix-acpi:
  + call ACPI suspend preparation methods in proper places with respect to PCI
    devices suspend/resume (#6785)
- Updated kernel-fix-core:
  + make rwsems use interrupt disabling spinlocks (fixes deadlock in
    dio_complete())
  + fix syscall table for UML
  + fix SMP crash in security/keys/key.c
- Added kernel-fix-drivers-i2c:
  + fix oops in the eeprom driver
  + fix sysfs permissions in it87 and via686a drivers (could cause oops if
    write is attempted)
  + fix multiple bugs in i2c-ali1563 driver
- Updated kernel-fix-drivers-media:
  + fix freeze on loading bttv in some configurations
- Updated kernel-fix-drivers-net:
  + fix irda-usb "badness" problem and sysfs support
- Updated kernel-fix-drivers-usb:
  + enable "old_scheme_first" and "use_both_schemes" parameters of usbcore by
    default (#6728)
- Updated kernel-fix-fs:
  + fix race in jbd code which could give oopses
- Updated kernel-fix-net:
  + fix deadlock in IPsec when sending ICMP "fragmentation needed" packet
  + fix binary search in the BIC congestion control algorithm
- Modified configuration:
  + enlarged kernel message buffer to 128 KB (#6366)
  + disabled software suspend support (does not work with modular drivers)
  + disabled buggy MTD drivers (#5994)
  + enabled NAPI support in starfire, r8169, ixgb, s2io drivers
  + enabled ISDN4Linux support
  + enabled OSS sound drivers (#6521)
  + disabled HID Boot Protocol drivers (usbkbd, usbmouse)
  + enabled EFI partition table support
- Build OSS sound drivers as a separate module package
  (kernel-modules-oss-%%flavour) (#6521).
- Fixed kernel-headers-%%flavour file list (some headers were missing).
- Fixed passing of config file to the kernel build system.
- Moved kernel-headers-%%flavour files to /usr/src/linux-%version-%flavour,
  leaving a symlink in /usr/include (fixes problems with third-party modules
  which don't like symlinks in the kernel source tree).
- Spec file cleanup, rewritten package descriptions.

* Tue Mar 29 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt6
- Updated kernel-fix-security:
  + fixed isofs corrupted filesystem handling (CAN-2005-0815)
  + fixed bluetooth range checking bug (CAN-2005-0750)
  + fixed ext2 information leak (CAN-2005-0400)
  + fixed binfmt_elf DoS (CAN-2005-0749)
- Updated kernel-fix-core:
  + fixed tasklist locking bug which caused hangs instead of reboot on SMP
- Updated kernel-fix-drivers-net:
  + fixed missing free_irq in error path in amd8111e and via-rhine drivers
  + fixed check for underflow in the tun driver
  + fixed kernel panic on receive in the hd6457x driver
- Updated kernel-fix-net:
  + fixed deadlock in NetROM
  + fixed crash when reading /proc/net/route
  + fixed bug in IPSEC support (__xfrm_find_acq_byseq)
- Fixed passing config file to the kernel build system (replacing defconfig was
  a broken way which worked before for some unknown reason).
- Removed hack which copied .config back to source.

* Wed Mar 16 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt5
- Updated kernel-fix-security:
  + fix ppp_async issue (CAN-2005-0384)
  + fix information leak through get_task_comm()

* Mon Mar 14 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.11-alt4
- 2.6.11 (really kernel-fix-* packages contain relevant patches from 2.6.11.3).
- Updated kernel-fix-security:
  + epoll: return proper error on overflow condition
- Updated kernel-fix-acpi, kernel-fix-core, kernel-fix-drivers-block,
  kernel-fix-drivers-md, kernel-fix-drivers-sound:
  - removed obsolete patches
- Updated kernel-fix-build:
  + fix "make htmldocs" failure
- Updated kernel-fix-drivers-ide:
  + fix no_lba48_dma flag handling in ide-disk (fixes DMA timeouts on old
    ALI15x3 controllers with a large disk)
- Updated kernel-fix-drivers-input:
  + make ACPI detection of i8042 controllers ia64-only (many x86 PCs have
    broken BIOS tables)
- Updated kernel-fix-drivers-net:
  + fix receive descriptor length setting in r8169
  + fix sis900 oops with preempt/SMP
  + fix via-rhine oops on shutdown with old chips without WOL support
- Updated kernel-fix-drivers-pci:
  + fix double free in the pciehp module
- Updated kernel-fix-drivers-usb:
  + fix cdc-acm oopses on disconnect
- Updated kernel-fix-fs:
  + fix stat for device nodes on cramfs
- Updated kernel-fix-net:
  + export tcp_timer_bug_msg for modular ipv6 build
- Updated kernel-feat-drivers-input:
  + updated trackpoint patch
  - removed alps patch (included in 2.6.11)
- Updated kernel-feat-drivers-video-splash:
  + new bootsplash patch for 2.6.11
- Added kernel-fix-drivers-char:
  + fix bug in drm setversion ioctl which could crash the X server
  + fix chip type for Radeon Yi ES1000 RN50
- Added kernel-fix-drivers-media:
  + fix saa7110 oops on modprobe
  + fix i2c message flags in video drivers
- Added kernel-feat-drivers-drm:
  + add VIA Unichrome driver (version 2.3.3)
- Removed kernel-fix-drivers-atm, kernel-fix-drivers-i2c,
  kernel-fix-drivers-serial, kernel-fix-drivers-parport (obsolete for 2.6.11).
- Modified configuration:
  + enabled all DRM modules (DRM sources from xorg-x11 6.8.2 no longer compile
    with kernel 2.6.11, but modules shipped with the kernel are new enough)
- Added Provides: kernel-modules-drm-%%flavour for compatibility.

* Wed Feb 09 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.10-alt3
- Build with gcc-3.4.
- Added kernel-fix-drivers-atm, kernel-fix-drivers-block,
  kernel-fix-drivers-i2c, kernel-fix-drivers-input, kernel-fix-drivers-md,
  kernel-fix-drivers-pci, kernel-fix-drivers-serial; updated kernel-fix-acpi,
  kernel-fix-core, kernel-fix-drivers-char, kernel-fix-drivers-ide,
  kernel-fix-drivers-scsi, kernel-fix-drivers-sound, kernel-fix-drivers-usb:
    + sync with 2.6.10-as3 patchset
- Modified configuration:
  + moved IDE support to modules
  + moved ext2 filesystem support to modules
  + disabled ALSA drivers (in-kernel version is too old, use separate
    kernel-modules-alsa-* packages which are updated)
- Changed /lib/modules/%%version-%%flavour-%%krelease/build symlink to point to
  %%_usrsrc/linux-%%version-%%flavour/ and moved it to the
  kernel-headers-modules-%%flavour subpackage.
- Added version to Provides: kernel-headers (#5872).
- Updated kernel-fix-drivers-ide:
  + added patch to fix endless partition rescan on PCMCIA flash (#5853).

* Sat Jan 08 2005 Sergey Vlasov <vsu@altlinux.ru> 2.6.10-alt2
- Removed broken symlink /lib/modules/%%version-%%flavour-%%krelease/source.
- Updated kernel-fix-security:
  + fix uselib() issue (CAN-2004-1235)
  + fix expand_stack issue (CAN-2005-0001)
  + fix integer signedness issues in moxa, random, scsi drivers
  + fix RLIMIT_MEMLOCK enforcement

* Wed Dec 29 2004 Sergey Vlasov <vsu@altlinux.ru> 2.6.10-alt1
- 2.6.10
- Added ccache support (was lost because of CC=gcc3.3 in the kernel
  makefile).
- Updated kernel-fix-build, kernel-fix-drivers-net, kernel-fix-net,
  kernel-feat-drivers-pktcdvd:
  - removed obsolete patches
- Updated kernel-fix-drivers-parport:
  + fixed parport_pc module parameters
- Updated kernel-feat-drivers-video-splash:
  + new bootsplash patch for 2.6.10
- Updated kernel-feat-net-ppp-mppe:
  + updated patch to version 1.2 (fixes CryptoAPI-related bug)
- Added kernel-fix-drivers-ieee1394:
  + remove broken MODULE_ALIAS_CHARDEV entries from ieee1394 modules (#3873)
- Removed kernel-fix-drivers-serial (obsolete).
- Modified configuration:
  + CONFIG_EDD is not set (causes boot problems, #5511)
  + CONFIG_APM_IGNORE_USER_SUSPEND is not set (apparently this option was set
    accidentally a long time ago and then forgotten)
  + CONFIG_GEN_RTC is not set (conflicts with the real RTC support)
  + CONFIG_FB_RADEON_OLD is not set (conflicts with the new radeonfb driver)
  + CONFIG_USB_DYNAMIC_MINORS is not set (#5484)
  + lots of new drivers enabled (too many to list here)

* Thu Oct 28 2004 Anton Farygin <rider@altlinux.ru> 2.6.9-alt11
- fixed iptables
- fixed kernel-headers for using with userspace programms (#5409)
- added kernel-feat-evms-nodm patch
- ppp fixed: terminate connection on hangup

* Wed Oct 20 2004 Anton Farygin <rider@altlinux.ru> 2.6.9-alt10
- new version

* Wed Aug 18 2004 Sergey Vlasov <vsu@altlinux.ru> 2.6.8-alt9
- Added missing scripts/gcc-version.sh to kernel-headers-modules.
- Removed libkconfig.so shared library to avoid extra dependencies in packages.

* Mon Aug 16 2004 Anton Farygin <rider@altlinux.ru> 2.6.8-alt8
- 2.6.8
- added patch for fix typo in nfs code (2.6.8.1)
- updated acpi subsystem to last stable release (20040717)
- updated bootsplash

* Thu Aug 05 2004 Anton Farygin <rider@altlinux.ru> 2.6.7-alt8
- Updated kernel-fix-security:
    + fix ppos races (CAN-2004-0415)

* Thu Jun 17 2004 Anton Farygin <rider@altlinux.ru> 2.6.7-alt7
- 2.6.7
- updated bootsplash patch
- added kernel-fix-drivers-net:
  + 2.6_50_eql-check-null.patch: add NULL checks to the eql driver
  + 2.6_51_airo-proc-fix.patch: fix airo /proc write breakage
- added kernel-fix-drivers-usb:
  + 2.6_51_phidgetservo-fixes.patch: fix use of freed memory in PhidgetServo
    driver
  + 2.6_52_storage-jumpshot-fix.patch: fix size reporting in the Lexar Jumpshot
    CF driver; avoid "unneeded entry" message with some devices
- added kernel-fix-drivers-scsi:
  + 2.6_50_sata_sil-mod15write.patch: fix Seagate+SiI3112 mod15write bug
    workaround broken by the LBA48 optimizations

* Tue Jun 15 2004 Anton Farygin <rider@altlinux.ru> 2.6.6-alt6
- kernel-fix-security added:
  + 2.6_50_fpu-exception.patch: fix FPU exception handling DoS

* Fri May 21 2004 Anton Farygin <rider@altlinux.ru> 2.6.6-alt5
- updated to last kernel-fix-ide and kernel-fix-fs patches:
  + 2.6_55_reiserfs-i_size-race.patch: fix reiserfs inode size update race
    which could lead to file corruption
  + 2.6_52_no-suspend-on-reboot.patch: replaced with better fix (flush drive
    cache on reboot)
  + 2.6_51_dquot_release-oops.patch: fix dquot_release oops with quota_v1
  + 2.6_52_quota-recursion.patch: fixes quota recursion into filesystem
  + 2.6_53_quota-recursion-fix.patch: fix the recursion fix
  + 2.6_54_quota-v2-corruption.diff: fix possible quota_v2 files corruption
    when root did not have any inodes&space allocated
- added kernel-feat-pktcdvd

* Mon May 17 2004 Anton Farygin <rider@altlinux.ru> 2.6.6-alt4
- config tuning:
    CONFIG_BLK_DEV_ATIIXP=y
    CONFIG_IP_NF_MATCH_IPRANGE=m
    CONFIG_IP_NF_MATCH_PHYSDEV=m
    * disabled debug on i2c
    * enabled ebtables
    * disabled CONFIG_FONT_MINI_4x6
    * moved CONFIG_X86_MCE_NONFATAL to modules
    * disabled CONFIG_IDEDMA_IVB
- added kernel-fix-drivers-ide (Sergey Vlasov) with:
  + 2.6_50_wcache-fixes.patch: fix write cache handling problems:
    + fix drive->wcache setting
    + send CACHE FLUSH (EXT) only if the drive claims to support it
    + fix for Maxtor disks falsely claiming CACHE FLUSH EXT support
  + 2.6_51_system_state.patch: differentiate between halt/poweroff/reboot
  + 2.6_52_no-suspend-on-reboot.patch: avoid drive spindown on reboot
    
* Tue May 11 2004 Anton Farygin <rider@altlinux.ru> 2.6.6-alt3
- 2.6.6
- fixed depends (kernel-headers-modules)
- added kernel-fix-acpi with:
    fixes IRQ12 sharing
- Added kernel-feat-drivers-console-unicode by Ivan Zakharyaschev <imz@altlinux.ru>:
  fixes the imperfectness of Linux VT/console Unicode support 
  (involves a change of the kernel interface used by loadkeys, 
  but mainly is compatible with old loadkeys).

* Mon Apr 05 2004 Anton Farygin <rider@altlinux.ru> 2.6.5-alt1
- update to 2.6.5
- updated patches and config from std26-up-2.6.5-alt1 kernel

* Thu Mar 22 2004 Anton Farygin <rider@altlinux.ru> 2.6.4-alt4
- first build for Sisyphus, based on kernel-image-std26-up with changes:
    enabled CONFIG_HIGHMEM64G
    enabled CONFIG_X86_SMP (CONFIG_NR_CPUS=8)
    enabled CONFIG_X86_HT
    enabled CONFIG_IRQBALANCE
    enabled CONFIG_MPENTIUM4
    
